#!/bin/sh

# When in build tree, threadexec is in directory below.
test -d frysk2130 && cd frysk2130

case `uname -r` in
    2.6.19-1.2895.fc6 | \
    2.6.19-1.2911.fc6 | \
    2.6.19-1.2911.6.4.fc6 | \
    2.6.19-1.2911.6.5.fc6)
	echo "Causes system hangs on kernel `uname -r` (http://sourceware.org/bugzilla/show_bug.cgi?id=3820)" 1>&2
	exit 77
	;;
esac

if which strace > /dev/null 2>&1 ; then
    strace -f -o /dev/null ./threadexec /bin/echo hi | grep hi
else
    echo "No strace installed; skipping" 1>&2
    exit 77
fi
